Bug 587198 - Review Request: jgraphx - Java Graph Drawing Component
Review Request: jgraphx - Java Graph Drawing Component
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
13
All Linux
low Severity medium
: ---
: ---
Assigned To: Markus Mayer
Fedora Extras Quality Assurance
:
: 537527 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-04-29 06:35 EDT by Lubomir Rintel
Modified: 2010-10-20 10:50 EDT (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-10-20 10:50:23 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
LotharLutz: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Lubomir Rintel 2010-04-29 06:35:53 EDT
SPEC: http://fedorapeople.org/~lkundrak/jgraphx.spec
SRPM: http://fedorapeople.org/~lkundrak/jgraphx-1.3.1.6-1.fc13.src.rpm

Description:

JGraphX is the a powerful, easy-to-use and feature-rich graph drawing
component for Java. It is a rewrite of JGraph, also known as JGraph 6.
Comment 1 Lubomir Rintel 2010-04-29 06:36:17 EDT
*** Bug 537527 has been marked as a duplicate of this bug. ***
Comment 2 Lubomir Rintel 2010-04-29 06:38:44 EDT
RPMlint only warns about sucky Source0 tag. Unluckily, the tarball can be only gotten after a POST request to an url.
Comment 3 Chen Lei 2010-05-01 06:25:42 EDT
Can we make scilab available as a new feature for F14?
Comment 4 Markus Mayer 2010-05-01 11:11:20 EDT
Version 1.4.0.0 is available now. Please think about using this.

All versions can be downloaded on http://www.jgraph.com/downloads/jgraphx/archive/ . Please use this as SOURCE0 in your SPEC-File.
Comment 5 Lubomir Rintel 2010-05-20 11:50:26 EDT
(In reply to comment #3)
> Can we make scilab available as a new feature for F14?    

This must be the worst place you could find to ask this.
Sure, try to make a feature page, propose it to FESCO and persuade them why is this worth being a feature.

(In reply to comment #4)
> Version 1.4.0.0 is available now. Please think about using this.

Would you mind doing a complete review?

SPEC: http://fedorapeople.org/~lkundrak/jgraphx.spec
SRPM: http://fedorapeople.org/~lkundrak/jgraphx-4.0.0.2-1.fc13.src.rpm
Comment 6 Lubomir Rintel 2010-05-20 11:58:30 EDT
Whoops, bad links. Good ones (hopefully):

SPEC: http://fedorapeople.org/~lkundrak/jgraphx.spec
SRPM: http://fedorapeople.org/~lkundrak/jgraphx-1.4.0.2-1.fc13.src.rpm
Comment 7 Markus Mayer 2010-05-20 12:12:14 EDT
taking this
Comment 8 Markus Mayer 2010-05-20 12:42:28 EDT
Just a few things for now.

According to https://fedoraproject.org/wiki/Packaging:Java

At a minimum, Java packages MUST:

BuildRequires: java-devel [>= specific_version] 
BuildRequires:  jpackage-utils

Requires:  java >= specific_version
Requires:  jpackage-utils

Group for javadoc should be "Development/Documentation"
Think about adding "Requires: Requires: %{name}-%{version}-%{release}
" to javadoc subpackage.


SOURCE0 is not a vaild URL. Try using: "http://www.jgraph.com/downloads/jgraphx/archive/%{name}-%(echo %{version} |sed 's/\./_/g').zip"

Your BuildRoot seams a little odd. Think about using "%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)" instead.

"find -name '*.jar' -delete" and "rm -rf docs/api" should be moved to "%prep". It is also a good idea to add "find -name '*.class' -delete" too.


I will continue reviewing after these things have been fixed.
Comment 9 Sylvestre Ledru 2010-05-21 07:38:55 EDT
For your information, jgraphx is regularly breaking backward compatibility (the compilation will work but the application based on jgraphx will fails). 

If you package jgraphx 1.4.0.2, it will break some behavior of Scilab. Scilab 5.2.2 expects jgraphx 1.2.0.8.

I can ask to the developer of the Scilab jgraphx-based component for a patch.
Comment 10 Alexander Kurtakov 2010-06-06 01:50:37 EDT
Markus, Please change the status of a bug to Assigned when you take it for review.
Thanks,
Alex
Comment 11 Lubomir Rintel 2010-09-20 15:09:58 EDT
(In reply to comment #8)
> Just a few things for now.
> 
> According to https://fedoraproject.org/wiki/Packaging:Java
> 
> At a minimum, Java packages MUST:
> 
> BuildRequires: java-devel [>= specific_version] 
> BuildRequires:  jpackage-utils
> 
> Requires:  java >= specific_version
> Requires:  jpackage-utils
> 
> Group for javadoc should be "Development/Documentation"
> Think about adding "Requires: Requires: %{name}-%{version}-%{release}
> " to javadoc subpackage.
> 
> 
> SOURCE0 is not a vaild URL. Try using:
> "http://www.jgraph.com/downloads/jgraphx/archive/%{name}-%(echo %{version} |sed
> 's/\./_/g').zip"

All of above fixed. Thanks!

> Your BuildRoot seams a little odd. Think about using
> "%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)" instead.

It's not. It's one of the permitted forms, and actually a preferred one. Not that it would matter, just the above one makes concurrent package builds racy with older rpm.

> "find -name '*.jar' -delete" and "rm -rf docs/api" should be moved to "%prep".
> It is also a good idea to add "find -name '*.class' -delete" too.

I could not find a definitive reason to do this and am keeping it as it is for consistency with existing packages (and a personal bias :); until I'm convinced otherwise (by a guideline or piece of rpm documentation).

(In reply to comment #9)
> For your information, jgraphx is regularly breaking backward compatibility (the
> compilation will work but the application based on jgraphx will fails). 
> 
> If you package jgraphx 1.4.0.2, it will break some behavior of Scilab. Scilab
> 5.2.2 expects jgraphx 1.2.0.8.
> 
> I can ask to the developer of the Scilab jgraphx-based component for a patch.

I quite honestly don't care. I won't mind a compatibility patch though, nor a compat package if needed, nor helping out anywhere (if needed).

SPEC: http://v3.sk/~lkundrak/jgraphx.spec
SRPM: http://v3.sk/~lkundrak/jgraphx-1.4.1.0-1.fc13.src.rpm
Comment 12 Markus Mayer 2010-09-21 15:53:45 EDT
Unfortunately I am not able to download any of these files. Please check if the url is correct.
Comment 13 Lubomir Rintel 2010-09-22 05:30:38 EDT
(In reply to comment #12)
> Unfortunately I am not able to download any of these files. Please check if the
> url is correct.

Uh, I suck. Sorry.

SPEC: http://v3.sk/~lkundrak/SPECS/jgraphx.spec
SRPM: http://v3.sk/~lkundrak/SRPMS/jgraphx-1.4.1.0-1.fc13.src.rpm
Comment 14 Markus Mayer 2010-09-22 16:42:49 EDT
Things that are OK:
OK    * MUST: rpmlint must be run on every package. The output should be posted in the review.[1]
OK    * MUST: The package must be named according to the Package Naming Guidelines .
OK    * MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
OK    * MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
OK    * MUST: The License field in the package spec file must match the actual license. [3]
OK    * MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
OK    * MUST: The spec file must be written in American English. [5]
OK    * MUST: The spec file for the package MUST be legible. [6]
OK    * MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
OK    * MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
NA    * MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
OK    * MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
OK    * MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
NA    * MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
OK    * MUST: Packages must NOT bundle copies of system libraries.[11]
NA    * MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [12]
OK    * MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [13]
OK    * MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)[14]
OK    * MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [15]
OK    * MUST: Each package must consistently use macros. [16]
OK    * MUST: The package must contain code, or permissable content. [17]
OK    * MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
OK    * MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
NA    * MUST: Header files must be in a -devel package. [19]
NA    * MUST: Static libraries must be in a -static package. [20]
NA    * MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]
NA    * MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [21]
NA    * MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
NA    * MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [22]
OK    * MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [23]
OK    * MUST: All filenames in rpm packages must be valid UTF-8. [24]

Things that are not OK:
NO    * MUST: The package must meet the Packaging Guidelines.
The Packaging:Guidelines says: "Remove all pre-built program binaries and program libraries in %prep prior to the building of the package."
So please move "find -name '*.jar' -delete" to %prep.

The URL "http://www.jgraph.com/jgraphx.html" is not valid. Please fix this

rpmlint output:
jgraphx.noarch: W: invalid-url URL: http://www.jgraph.com/jgraphx.html HTTP Error 404: Not Found
jgraphx.src: W: invalid-url URL: http://www.jgraph.com/jgraphx.html HTTP Error 404: Not Found
jgraphx-javadoc.noarch: W: non-standard-group Development/Documentation
jgraphx-javadoc.noarch: W: invalid-url URL: http://www.jgraph.com/jgraphx.html HTTP Error 404: Not Found

W: invalid-url should be fixed.
W: non-standard-group is OK.

Package builds fine in mock.

After fixing the URL and moving "find -name '*.jar' -delete" to %prep I will approve this package.
Comment 16 Markus Mayer 2010-09-30 13:20:18 EDT
- rpmlint output is clean.
- Package builds fine in mock

This package is APPROVED
Comment 17 Lubomir Rintel 2010-10-08 10:02:57 EDT
New Package SCM Request
=======================
Package Name: jgraphx
Short Description: Java Graph Drawing Component
Owners: lkundrak
Branches: f12 f13 f14 el6
Comment 18 Kevin Fenzi 2010-10-08 16:29:50 EDT
Git done (by process-git-requests).
Comment 19 Lubomir Rintel 2010-10-20 10:50:23 EDT
Imported and built. Thank you!

Note You need to log in before you can comment on or make changes to this bug.